unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, RXSpin, Placemnt, RXSwitch, Spin, Mask;

type
  TForm1 = class(TForm)
    Timer0: TTimer;
    Label1: TLabel;
    FormStorage1: TFormStorage;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SignalPanel: TPanel;
    Panel2: TPanel;
    PaintBox1: TPaintBox;
    RxSwitch1: TRxSwitch;
    CheckBox1: TCheckBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    RxSpinEdit1: TRxSpinEdit;
    Label8: TLabel;
    SpinEdit1: TSpinEdit;
    Label9: TLabel;
    Panel3: TPanel;
    PaintBox2: TPaintBox;
    RxSwitch2: TRxSwitch;
    CheckBox2: TCheckBox;
    RxSpinEdit2: TRxSpinEdit;
    SpinEdit2: TSpinEdit;
    Panel4: TPanel;
    PaintBox3: TPaintBox;
    RxSwitch3: TRxSwitch;
    CheckBox3: TCheckBox;
    RxSpinEdit3: TRxSpinEdit;
    SpinEdit3: TSpinEdit;
    Pause: TCheckBox;
    COMPort: TSpinEdit;
    Label10: TLabel;
    SpinEdit4: TSpinEdit;
    SpinEdit5: TSpinEdit;
    SpinEdit6: TSpinEdit;
    Timer1: TTimer;
    Timer2: TTimer;
    Timer3: TTimer;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure COMPortChange(Sender: TObject);
    procedure COMPortKeyPress(Sender: TObject; var Key: Char);
    procedure RxSwitch1On(Sender: TObject);
    procedure RxSwitch1Off(Sender: TObject);
    procedure Timer0Timer(Sender: TObject);
    procedure PauseClick(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ClearCOM;
    procedure ShiftSignal;
    procedure ShowSignal;
  end;

const
  SignalsAmount=3;
  HistoryLength=300;
var
  Form1: TForm1;
  H: THandle;
  Signal: array[1..SignalsAmount,0..HistoryLength] of SmallInt; // 0 - "0", 1 - "1"(+Vs), -1 - -Vs, 3 - Z-State
                                 // 0 - Current Values;
  LastIndex: Integer=HistoryLength;
  C1,C2,C3: Integer;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var I,J: Integer;
begin
  for I:=1 to SignalsAmount do
    for J:=0 to HistoryLength do Signal[I,J]:=0;
  FormStorage1.RestoreFormPlacement;
  COMPortChange(nil);
  Timer0.Enabled:=True;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer0.Enabled:=False;
  CloseHandle(H);
end;

procedure TForm1.COMPortChange(Sender: TObject);
begin
  CloseHandle(H);
  H:=CreateFile(PChar('\\.\COM'+IntToStr(COMPort.Value)),GENERIC_WRITE,0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
  if H=INVALID_HANDLE_VALUE then begin
    Label1.Font.Color:=clRed;
//    ShowMessage('Error opening COM'+IntToStr(COMPort.Value)+': !')
  end else begin
    Label1.Font.Color:=clGreen;
    ClearCOM;
  end;
end;

procedure TForm1.COMPortKeyPress(Sender: TObject; var Key: Char);
begin
  Key:=#0;
end;

procedure TForm1.RxSwitch1On(Sender: TObject);
var I: Integer;
begin
  if H=INVALID_HANDLE_VALUE then //ShowMessage('COM-Port isn''t opened !')
  else begin
    I:=TControl(Sender).Parent.Tag;
    case I of
    1: EscapeCommFunction(H,SETRTS);
    2: EscapeCommFunction(H,SETDTR);
    3: SetCommBreak(H);
    end;
    Signal[I,0]:=1;
    Signal[I,LastIndex]:=1;
  end;
end;

procedure TForm1.RxSwitch1Off(Sender: TObject);
var I: Integer;
begin
  if H=INVALID_HANDLE_VALUE then //ShowMessage('COM-Port isn''t opened !')
  else begin
    I:=TControl(Sender).Parent.Tag;
    case I of
    1: EscapeCommFunction(H,CLRRTS);
    2: EscapeCommFunction(H,CLRDTR);
    3: ClearCommBreak(H);
    end;
    Signal[I,0]:=0;
    Signal[I,LastIndex]:=0;
  end;
end;

procedure TForm1.ClearCOM;
var I,J: Integer;
begin
  if H=INVALID_HANDLE_VALUE then //ShowMessage('COM-Port isn''t opened !')
  else begin
    EscapeCommFunction(H,CLRRTS);
    EscapeCommFunction(H,CLRDTR);
    ClearCommBreak(H);
    for I:=1 to SignalsAmount do with TWinControl(SignalPanel.Controls[I-1]) do begin
      Signal[I,0]:=0;
      for J:=0 to ControlCount-1 do
        if Controls[J] is TRxSwitch then TRxSwitch(Controls[J]).StateOn:=False;
    end;
  end;
end;

procedure TForm1.ShiftSignal;
var I: Integer;
begin
  Inc(LastIndex);
  if LastIndex=HistoryLength+1 then LastIndex:=1;
  for I:=1 to SignalsAmount do Signal[I,LastIndex]:=Signal[I,0];
  ShowSignal;
end;

procedure TForm1.Timer0Timer(Sender: TObject);
begin
  if Timer0.Tag=1 then exit;
  Timer0.Tag:=1;
  ShiftSignal;
  Timer0.Tag:=0;
end;

procedure TForm1.ShowSignal;
var I,J,K: Integer;
begin
  for I:=1 to SignalsAmount do
    for J:=0 to HistoryLength-1 do with TWinControl(SignalPanel.Controls[I-1]) do
      for K:=0 to ControlCount-1 do
        if Controls[K] is TPaintBox then
          with TPaintBox(Controls[K]), TPaintBox(Controls[K]).Canvas do begin
            if J=0 then begin
              Pen.Color:=clBtnFace;
              Fillrect(Rect(0,0,Width,Height));
              Pen.Color:=clBlue;
              MoveTo(0,Height-2-Signal[I,((LastIndex) mod HistoryLength)+1] shl 4)
            end else LineTo(J,Height-2-Signal[I,((LastIndex+J) mod HistoryLength)+1] shl 4);
          end;
end;

procedure TForm1.PauseClick(Sender: TObject);
begin
  Timer0.Enabled:=not Pause.Checked;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  with Timer1 do begin
    Interval:=SpinEdit1.Value;
    if Enabled then begin Enabled:=False; Enabled:=True; end;
  end;
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
  with Timer2 do begin
    Interval:=SpinEdit2.Value;
    if Enabled then begin Enabled:=False; Enabled:=True; end;
  end;
end;

procedure TForm1.SpinEdit3Change(Sender: TObject);
begin
  with Timer3 do begin
    Interval:=SpinEdit3.Value;
    if Enabled then begin Enabled:=False; Enabled:=True; end;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  C1:=Round(RxSpinEdit1.Value);
  Timer1.Interval:=SpinEdit1.Value;
  Timer1.Enabled:=CheckBox1.Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  C2:=Round(RxSpinEdit2.Value);
  Timer2.Interval:=SpinEdit2.Value;
  Timer2.Enabled:=CheckBox2.Checked;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  C3:=Round(RxSpinEdit3.Value);
  Timer3.Interval:=SpinEdit3.Value;
  Timer3.Enabled:=CheckBox3.Checked;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var T: TDateTime;
begin
  if Timer1.Tag=1 then exit;
  Timer1.Tag:=1;
  RxSwitch1On(RxSwitch1);
  T:=Now+SpinEdit4.Value/24/3600/1000;
  while Now<T do Application.ProcessMessages;
  RxSwitch1Off(RxSwitch1);
  Dec(C1);
  if C1=0 then begin Timer1.Enabled:=False; CheckBox1.Checked:=False; end;
  Timer1.Tag:=0;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var T: TDateTime;
begin
  if Timer2.Tag=1 then exit;
  Timer2.Tag:=1;
  RxSwitch1On(RxSwitch2);
  T:=Now+SpinEdit5.Value/24/3600/1000;
  while Now<T do Application.ProcessMessages;
  RxSwitch1Off(RxSwitch2);
  Dec(C2);
  if C2=0 then begin Timer2.Enabled:=False; CheckBox2.Checked:=False; end;
  Timer2.Tag:=0;
end;

procedure TForm1.Timer3Timer(Sender: TObject);
var T: TDateTime;
begin
  if Timer3.Tag=1 then exit;
  Timer3.Tag:=1;
  RxSwitch1On(RxSwitch3);
  T:=Now+SpinEdit6.Value/24/3600/1000;
  while Now<T do Application.ProcessMessages;
  RxSwitch1Off(RxSwitch3);
  Dec(C3);
  if C3=0 then begin Timer3.Enabled:=False; CheckBox3.Checked:=False; end;
  Timer3.Tag:=0;
end;

end.
